// PagePowersave.cpp : implementation file
//

#include "stdafx.h"
#include "TrackDemo.h"
#include "PagePowersave.h"
#include "..\VSMSGW\VSMSGW.h"


// CPagePowersave dialog

IMPLEMENT_DYNAMIC(CPagePowersave, CPropertyPage)

CPagePowersave::CPagePowersave()
  : CPropertyPage(CPagePowersave::IDD)
  , m_ignition(0)
  , m_gpsmove(0)
  , m_timeout(0)
  , m_powersave(0)
  , m_vibration(0)
{
}

CPagePowersave::~CPagePowersave()
{
}

void CPagePowersave::DoDataExchange(CDataExchange* pDX)
{
  CPropertyPage::DoDataExchange(pDX);
  DDX_Text(pDX, IDC_IGNITION, m_ignition);
  DDX_Text(pDX, IDC_NOGPS, m_gpsmove);
  DDX_Text(pDX, IDC_TIMEOUT, m_timeout);
  DDX_Text(pDX, IDC_POWERSAVE, m_powersave);
  DDX_Text(pDX, IDC_VIBRATION, m_vibration);
}


BEGIN_MESSAGE_MAP(CPagePowersave, CPropertyPage)
  ON_BN_CLICKED(IDC_SET, &CPagePowersave::OnSet)
  ON_BN_CLICKED(IDC_GET, &CPagePowersave::OnGet)
  ON_REGISTERED_MESSAGE(UWM_UPDATE_WINDOW, &CPagePowersave::OnUpdateView)
END_MESSAGE_MAP()


// CPagePowersave message handlers

BOOL CPagePowersave::OnInitDialog()
{
  // Default
  CPropertyPage::OnInitDialog();

  // Initialize controls
  ((CEdit*)GetDlgItem(IDC_IGNITION))->LimitText(3);
  ((CEdit*)GetDlgItem(IDC_NOGPS))->LimitText(5);
  ((CEdit*)GetDlgItem(IDC_TIMEOUT))->LimitText(3);
  ((CEdit*)GetDlgItem(IDC_POWERSAVE))->LimitText(5);
  ((CEdit*)GetDlgItem(IDC_VIBRATION))->LimitText(2);

  // Retreive saved values from registry
  m_ignition        = AfxGetApp()->GetProfileInt(_T("Powedown"), _T("IgnitionTime"), 0);
  m_gpsmove         = AfxGetApp()->GetProfileInt(_T("Powedown"), _T("GpsNoMoveTime"), 0);
  m_powersave       = AfxGetApp()->GetProfileInt(_T("Powedown"), _T("PowersaveTime"), 0);
  m_vibration       = AfxGetApp()->GetProfileInt(_T("Powedown"), _T("Vibration"), 0);
  m_timeout         = AfxGetApp()->GetProfileInt(_T("Powedown"), _T("NoGpsDelay"), 0);

  // Update view
  UpdateData(FALSE);

  // Completed
  return TRUE;
}

void CPagePowersave::OnSet()
{
  // Var
  struct FrameSetPowersave req;
  int rc;

  // Retreive data from dialog
  if (!UpdateData(TRUE)) return;

  // Update Registry
  AfxGetApp()->WriteProfileInt(_T("Powedown"), _T("IgnitionTime"),    m_ignition);
  AfxGetApp()->WriteProfileInt(_T("Powedown"), _T("GpsNoMoveTime"),   m_gpsmove);
  AfxGetApp()->WriteProfileInt(_T("Powedown"), _T("PowersaveTime"),   m_powersave);
  AfxGetApp()->WriteProfileInt(_T("Powedown"), _T("Vibration"),       m_vibration);
  AfxGetApp()->WriteProfileInt(_T("Powedown"), _T("NoGpsDelay"),      m_timeout);

  // Build frame
  memset(&req, 0, sizeof(struct FrameSetPowersave));
  req.Command         = 0x07;
  req.Ignition        = m_ignition;
  req.Timeout         = m_timeout;
  req.GpsMove         = m_gpsmove;
  req.Vibration       = m_vibration;
  req.PowersaveTime   = m_powersave;

  // Send command
  if (vsmsgwSendPDU(AfxGetApp()->GetProfileInt(_T("Options"), _T("His nodeid"), 2001), (unsigned char*)&req, sizeof(req), &rc) || rc)
    MessageBox(_T("No responce from unit"), _T("Set powersave parameters"), MB_OK|MB_ICONWARNING);
}

void CPagePowersave::OnGet()
{
  // Var
  unsigned char Command = 0x08;
  int rc;

  // Send request
  if (vsmsgwSendPDU(AfxGetApp()->GetProfileInt(_T("Options"), _T("His nodeid"), 2001), &Command, 1, &rc) || rc)
    MessageBox(_T("No responce from unit"), _T("Get powersave parameters"), MB_OK|MB_ICONWARNING);
}

void CPagePowersave::OnReceive(struct FrameSetPowersave *pData)
{
  // Update dialog
  m_ignition        = pData->Ignition;
  m_gpsmove         = pData->GpsMove;
  m_powersave       = pData->PowersaveTime;
  m_vibration       = pData->Vibration;
  m_timeout         = pData->Timeout;
  PostMessage(UWM_UPDATE_WINDOW, 0, 0);

  // Update Registry
  AfxGetApp()->WriteProfileInt(_T("Powedown"), _T("IgnitionTime"),    m_ignition);
  AfxGetApp()->WriteProfileInt(_T("Powedown"), _T("GpsNoMoveTime"),   m_gpsmove);
  AfxGetApp()->WriteProfileInt(_T("Powedown"), _T("PowersaveTime"),   m_powersave);
  AfxGetApp()->WriteProfileInt(_T("Powedown"), _T("Vibration"),       m_vibration);
  AfxGetApp()->WriteProfileInt(_T("Powedown"), _T("NoGpsDelay"),      m_timeout);
}

LRESULT CPagePowersave::OnUpdateView(WPARAM /*wParam*/, LPARAM /*lParam*/)
{
  UpdateData(FALSE);
  return 0;
}
